using System;
using System.Windows.Forms;
using System.Xml;
using System.IO;

namespace UserChat
{
	/// <summary>
	/// Summary description for NT_CONSTANTS.
	/// </summary>
	public class NT_CONSTANTS
	{
		public int POWER_RANGE;
		private XmlDocument xmlDoc;
		
		public NT_CONSTANTS()
		{
			xmlDoc = new XmlDocument();
			xmlDoc.Load(new StreamReader("\\My Documents\\Personal\\GEN_basicInfo.xml"));
			POWER_RANGE = getPowerRangeFromBasicInfoXML();
		}

		private int getPowerRangeFromBasicInfoXML()
		{
			try
			{
				XmlNode root = xmlDoc.DocumentElement;//configuration root element
				XmlNodeList xNodes = root.ChildNodes;
				string temp_PR ="-1";
				foreach(XmlNode childNode in xNodes)
				{
					XmlElement currentElement = (XmlElement)childNode;
					if(currentElement.Name.Equals("PowerRange"))
					{
                        temp_PR = currentElement.FirstChild.Value;
						break;
					}
				}
                return int.Parse(temp_PR);
			}
			catch(Exception e)
			{
                MessageBox.Show("Exception in getPowerRangeFromBasicInfoXML(): "+e.Message);
				return -1;
			}
		}
	}
}
