using System;
using System.Collections;
using System.Windows.Forms;

namespace UserChat
{
	//DEBUG IS DONE!!!
	/// <summary>
	/// This class is to construct Route Cache to store identified paths 
	/// to reach a certain destination.
	/// </summary>
	public class RouteCache
	{
		private ArrayList CacheList;
		private ArrayList SynchCacheList;
		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="p_source">set a source and declare Hashtable</param>
		public RouteCache()
		{
			CacheList = new ArrayList();
			SynchCacheList = ArrayList.Synchronized(CacheList);
		}

		public string showRouteCacheInside()
		{
            string inside = "N/A";
			try
			{
				if(SynchCacheList.Count!=0)
				{
                    inside = SynchCacheList.Count+" : ";
					for(int i =0; i<SynchCacheList.Count; i++)
					{
                        inside += SynchCacheList[i].ToString()+"\r\n";
					}
				}
			}
			catch(Exception e)
			{
               MessageBox.Show("Exception in showRouteCacheInside(): "+e.Message);
			}
			return inside;
		}
		/// <summary>
		/// Add p_path to CacheList
		/// </summary>
		/// <param name="p_path">path</param>
		/// <param name="p_OnCache">On or Off</param>
		public void AddPath(string p_path, bool p_OnCache)
		{
			try
			{
				if(p_OnCache) 
				{
					if(!SynchCacheList.Contains(p_path))
					{
						SynchCacheList.Insert(0, p_path);
					}
				}
				else 
				{
					SynchCacheList.Clear();
					SynchCacheList.Add(p_path);
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in AddPath(): "+e.Message);
			}
		}


		public string getNumOfRoutesInCache()
		{
			int numOfRoutes = 0;
			try
			{				
				numOfRoutes = SynchCacheList.Count;
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getNumOfRoutesInCache():" +e.Message);
			}
			return numOfRoutes.ToString();						
		}

		private string getShortestPath()
		{
			string path ="";
			try
			{
				int shortestLength  = int.MaxValue;
				for(int i =0; i<SynchCacheList.Count; i++)
				{
					string temp = SynchCacheList[i].ToString();
					if(shortestLength>temp.Length)
					{
						shortestLength = temp.Length;
						path = temp;
					}
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getShortestPath(): "+e.Message);
			}
			return path;
		}

		public string getPath()
		{
			string path ="";
			try
			{
				if(SynchCacheList.Count!=0)
				{
					path = getShortestPath();
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in getProperPath(): "+e.Message);
			}
			return path;
		}
		public bool RemovePath(string p_path)
		{
			try
			{
				if(SynchCacheList.Contains(p_path))
				{
					SynchCacheList.Remove(p_path);
					return true;
				}
				return false;
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in RemovePath(): "+e.Message);
				return false;
			}
		}
		public bool isEmpty()
		{
			if(SynchCacheList.Count == 0)
			{
				return true;
			}
			return false;
		}


		public void Clear()
		{			
			SynchCacheList.Clear();
		}
		
		public bool hasPath(string p_path)
		{			
			try
			{
				if(SynchCacheList.Contains(p_path))
				{
					return true;
				}
			}
			catch(Exception e)
			{
				MessageBox.Show("Exception in hasPath(): "+e.Message);
			}
			return false;
		}

	}//class
}
